﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using System.Timers;
using System.Windows.Threading;
using System.ComponentModel;
using System.Windows.Data;
using System.Windows.Controls;

namespace WpfApplication1
{
    public class SecondWindowViewModel
    {
        ObservableCollection<string> mTestingList;
        Timer mTimer;
        Dispatcher mDispatcher;
        int mCounter = 0;

        public ObservableCollection<string> TestingList
        {
            get { return mTestingList; }
        }

        public SecondWindowViewModel()
        {
            mDispatcher = Dispatcher.CurrentDispatcher;

            mTestingList = new ObservableCollection<string>();
            
            mTimer = new Timer(1000);
            mTimer.Elapsed += new ElapsedEventHandler(mTimer_Elapsed);
            mTimer.Start();
        }

        void mTimer_Elapsed(object sender, ElapsedEventArgs e)
        {
            mCounter++;
            string sLine = "Line " + mCounter.ToString() + " - " + DateTime.Now.ToLongTimeString();

            DispatcherOperationCallback callback = delegate(object state)
            {
                TestingList.Add(sLine);
                ICollectionView view = CollectionViewSource.GetDefaultView(TestingList);
                view.MoveCurrentToLast();
                return null;
            };
            mDispatcher.BeginInvoke(callback, DispatcherPriority.Normal, new object());
            
        }
    }
}
